diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/global-router-interface.cc ns-3.39/src/internet/model/global-router-interface.cc
--- ns-3.38/src/internet/model/global-router-interface.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/global-router-interface.cc	2023-07-05 14:23:47.845427500 -0700
@@ -20,13 +20,13 @@
 #include "global-router-interface.h"
 
 #include "ipv4-global-routing.h"
+#include "ipv4.h"
 #include "loopback-net-device.h"
 
 #include "ns3/abort.h"
 #include "ns3/assert.h"
 #include "ns3/bridge-net-device.h"
 #include "ns3/channel.h"
-#include "ns3/ipv4.h"
 #include "ns3/log.h"
 #include "ns3/net-device.h"
 #include "ns3/node-list.h"
@@ -791,7 +791,7 @@
     // is a transit network.
     //
     ClearBridgesVisited();
-    if (AnotherRouterOnLink(nd) == false)
+    if (!AnotherRouterOnLink(nd))
     {
         //
         // This is a net device connected to a stub network
@@ -831,29 +831,29 @@
         // case.
         //
         ClearBridgesVisited();
-        Ipv4Address desigRtr;
-        desigRtr = FindDesignatedRouterForLink(nd);
+        Ipv4Address designatedRtr;
+        designatedRtr = FindDesignatedRouterForLink(nd);
 
         //
         // Let's double-check that any designated router we find out on our
         // network is really on our network.
         //
-        if (desigRtr != "255.255.255.255")
+        if (designatedRtr != "255.255.255.255")
         {
             Ipv4Address networkHere = addrLocal.CombineMask(maskLocal);
-            Ipv4Address networkThere = desigRtr.CombineMask(maskLocal);
+            Ipv4Address networkThere = designatedRtr.CombineMask(maskLocal);
             NS_ABORT_MSG_UNLESS(
                 networkHere == networkThere,
                 "GlobalRouter::ProcessSingleBroadcastLink(): Network number confusion ("
-                    << addrLocal << "/" << maskLocal.GetPrefixLength() << ", " << desigRtr << "/"
-                    << maskLocal.GetPrefixLength() << ")");
+                    << addrLocal << "/" << maskLocal.GetPrefixLength() << ", " << designatedRtr
+                    << "/" << maskLocal.GetPrefixLength() << ")");
         }
-        if (desigRtr == addrLocal)
+        if (designatedRtr == addrLocal)
         {
             c.Add(nd);
             NS_LOG_LOGIC("Node " << node->GetId() << " elected a designated router");
         }
-        plr->SetLinkId(desigRtr);
+        plr->SetLinkId(designatedRtr);
 
         //
         // OSPF says that the Link Data is this router's own IP address.
@@ -921,7 +921,7 @@
   //
 
   bool areTransitNetwork = false;
-  Ipv4Address desigRtr ("255.255.255.255");
+  Ipv4Address designatedRtr ("255.255.255.255");
 
   for (uint32_t i = 0; i < bnd->GetNBridgePorts (); ++i)
     {
@@ -945,24 +945,24 @@
           // all.
           //
           ClearBridgesVisited ();
-          Ipv4Address desigRtrTemp = FindDesignatedRouterForLink (ndTemp);
+          Ipv4Address designatedRtrTemp = FindDesignatedRouterForLink (ndTemp);
 
           //
           // Let's double-check that any designated router we find out on our
           // network is really on our network.
           //
-          if (desigRtrTemp != "255.255.255.255")
+          if (designatedRtrTemp != "255.255.255.255")
             {
               Ipv4Address networkHere = addrLocal.CombineMask (maskLocal);
-              Ipv4Address networkThere = desigRtrTemp.CombineMask (maskLocal);
+              Ipv4Address networkThere = designatedRtrTemp.CombineMask (maskLocal);
               NS_ABORT_MSG_UNLESS (networkHere == networkThere,
                                    "GlobalRouter::ProcessSingleBroadcastLink(): Network number confusion (" <<
                                    addrLocal << "/" << maskLocal.GetPrefixLength () << ", " <<
-                                   desigRtrTemp << "/" << maskLocal.GetPrefixLength () << ")");
+                                   designatedRtrTemp << "/" << maskLocal.GetPrefixLength () << ")");
             }
-          if (desigRtrTemp < desigRtr)
+          if (designatedRtrTemp < designatedRtr)
             {
-              desigRtr = desigRtrTemp;
+              designatedRtr = designatedRtrTemp;
             }
         }
     }
@@ -1013,12 +1013,12 @@
       // gets the IP interface address of the designated router in this
       // case.
       //
-      if (desigRtr == addrLocal)
+      if (designatedRtr == addrLocal)
         {
           c.Add (nd);
           NS_LOG_LOGIC ("Node " << node->GetId () << " elected a designated router");
         }
-      plr->SetLinkId (desigRtr);
+      plr->SetLinkId (designatedRtr);
 
       //
       // OSPF says that the Link Data is this router's own IP address.
@@ -1290,7 +1290,7 @@
         Ptr<NetDevice> nd = ch->GetDevice(i);
         NS_LOG_LOGIC("checking to see if the device " << nd << " is bridged");
         Ptr<BridgeNetDevice> bnd = NetDeviceIsBridged(nd);
-        if (bnd && BridgeHasAlreadyBeenVisited(bnd) == false)
+        if (bnd && !BridgeHasAlreadyBeenVisited(bnd))
         {
             NS_LOG_LOGIC("Device is bridged by BridgeNetDevice "
                          << bnd << " with " << bnd->GetNBridgePorts() << " ports");
@@ -1337,7 +1337,7 @@
     NS_LOG_LOGIC("Looking for designated router off of net device " << ndLocal << " on node "
                                                                     << ndLocal->GetNode()->GetId());
 
-    Ipv4Address desigRtr("255.255.255.255");
+    Ipv4Address designatedRtr("255.255.255.255");
 
     //
     // Look through all of the devices on the channel to which the net device
@@ -1402,8 +1402,8 @@
                                     "primary one");
                     }
                     Ipv4Address addrOther = ipv4->GetAddress(interfaceOther, 0).GetLocal();
-                    desigRtr = addrOther < desigRtr ? addrOther : desigRtr;
-                    NS_LOG_LOGIC("designated router now " << desigRtr);
+                    designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
+                    NS_LOG_LOGIC("designated router now " << designatedRtr);
                 }
             }
 
@@ -1433,8 +1433,8 @@
 
                 NS_LOG_LOGIC("Recursively looking for routers down bridge port " << ndBridged);
                 Ipv4Address addrOther = FindDesignatedRouterForLink(ndBridged);
-                desigRtr = addrOther < desigRtr ? addrOther : desigRtr;
-                NS_LOG_LOGIC("designated router now " << desigRtr);
+                designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
+                NS_LOG_LOGIC("designated router now " << designatedRtr);
             }
         }
         else
@@ -1466,13 +1466,13 @@
                                     "primary one");
                     }
                     Ipv4Address addrOther = ipv4->GetAddress(interfaceOther, 0).GetLocal();
-                    desigRtr = addrOther < desigRtr ? addrOther : desigRtr;
-                    NS_LOG_LOGIC("designated router now " << desigRtr);
+                    designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
+                    NS_LOG_LOGIC("designated router now " << designatedRtr);
                 }
             }
         }
     }
-    return desigRtr;
+    return designatedRtr;
 }
 
 //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/icmpv4-l4-protocol.cc ns-3.39/src/internet/model/icmpv4-l4-protocol.cc
--- ns-3.38/src/internet/model/icmpv4-l4-protocol.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/icmpv4-l4-protocol.cc	2023-07-05 14:23:47.845427500 -0700
@@ -20,13 +20,14 @@
 #include "icmpv4-l4-protocol.h"
 
 #include "ipv4-interface.h"
-#include "ipv4-l3-protocol.h"
 #include "ipv4-raw-socket-factory-impl.h"
+#include "ipv4-route.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
+#include "ipv6-interface.h"
 
 #include "ns3/assert.h"
 #include "ns3/boolean.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv6-interface.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
@@ -289,7 +290,7 @@
     Forward(source, icmp, 0, ipHeader, payload);
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 Icmpv4L4Protocol::Receive(Ptr<Packet> p,
                           const Ipv4Header& header,
                           Ptr<Ipv4Interface> incomingInterface)
@@ -342,7 +343,7 @@
     return IpL4Protocol::RX_OK;
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 Icmpv4L4Protocol::Receive(Ptr<Packet> p,
                           const Ipv6Header& header,
                           Ptr<Ipv6Interface> incomingInterface)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/icmpv4-l4-protocol.h ns-3.39/src/internet/model/icmpv4-l4-protocol.h
--- ns-3.38/src/internet/model/icmpv4-l4-protocol.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/icmpv4-l4-protocol.h	2023-07-05 14:23:47.845427500 -0700
@@ -81,9 +81,9 @@
      * \param incomingInterface the interface from which the packet is coming
      * \returns the receive status
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv4Header& header,
-                                        Ptr<Ipv4Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv4Header& header,
+                                   Ptr<Ipv4Interface> incomingInterface) override;
 
     /**
      * \brief Receive method.
@@ -92,9 +92,9 @@
      * \param incomingInterface the interface from which the packet is coming
      * \returns the receive status
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv6Header& header,
-                                        Ptr<Ipv6Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv6Header& header,
+                                   Ptr<Ipv6Interface> incomingInterface) override;
 
     /**
      * \brief Send a Destination Unreachable - Fragmentation needed ICMP error
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/icmpv6-l4-protocol.cc ns-3.39/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.38/src/internet/model/icmpv6-l4-protocol.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/icmpv6-l4-protocol.cc	2023-07-05 14:23:47.845427500 -0700
@@ -24,13 +24,13 @@
 
 #include "ipv6-interface.h"
 #include "ipv6-l3-protocol.h"
+#include "ipv6-route.h"
+#include "ipv6-routing-protocol.h"
 
 #include "ns3/assert.h"
 #include "ns3/boolean.h"
 #include "ns3/double.h"
 #include "ns3/integer.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-routing-protocol.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
@@ -284,7 +284,7 @@
                         Ipv6Address::MakeSolicitedAddress(target));
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 Icmpv6L4Protocol::Receive(Ptr<Packet> packet,
                           const Ipv4Header& header,
                           Ptr<Ipv4Interface> interface)
@@ -293,7 +293,7 @@
     return IpL4Protocol::RX_ENDPOINT_UNREACH;
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 Icmpv6L4Protocol::Receive(Ptr<Packet> packet,
                           const Ipv6Header& header,
                           Ptr<Ipv6Interface> interface)
@@ -446,7 +446,7 @@
         defaultRouter = src;
     }
 
-    while (next == true)
+    while (next)
     {
         uint8_t type = 0;
         p->CopyData(&type, sizeof(type));
@@ -688,7 +688,7 @@
     bool next = true;
     bool hasSllao = false;
 
-    while (next == true)
+    while (next)
     {
         uint8_t type;
         packet->CopyData(&type, sizeof(type));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/icmpv6-l4-protocol.h ns-3.39/src/internet/model/icmpv6-l4-protocol.h
--- ns-3.38/src/internet/model/icmpv6-l4-protocol.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/icmpv6-l4-protocol.h	2023-07-05 14:23:47.845427500 -0700
@@ -328,9 +328,9 @@
      * \param interface the interface from which the packet is coming
      * \returns the receive status
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv4Header& header,
-                                        Ptr<Ipv4Interface> interface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv4Header& header,
+                                   Ptr<Ipv4Interface> interface) override;
 
     /**
      * \brief Receive method.
@@ -339,9 +339,9 @@
      * \param interface the interface from which the packet is coming
      * \returns the receive status
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv6Header& header,
-                                        Ptr<Ipv6Interface> interface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv6Header& header,
+                                   Ptr<Ipv6Interface> interface) override;
 
     /**
      * \brief Function called when DAD timeout.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-end-point.cc ns-3.39/src/internet/model/ipv4-end-point.cc
--- ns-3.38/src/internet/model/ipv4-end-point.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-end-point.cc	2023-07-05 14:23:47.845427500 -0700
@@ -51,7 +51,7 @@
 }
 
 Ipv4Address
-Ipv4EndPoint::GetLocalAddress()
+Ipv4EndPoint::GetLocalAddress() const
 {
     NS_LOG_FUNCTION(this);
     return m_localAddr;
@@ -65,21 +65,21 @@
 }
 
 uint16_t
-Ipv4EndPoint::GetLocalPort()
+Ipv4EndPoint::GetLocalPort() const
 {
     NS_LOG_FUNCTION(this);
     return m_localPort;
 }
 
 Ipv4Address
-Ipv4EndPoint::GetPeerAddress()
+Ipv4EndPoint::GetPeerAddress() const
 {
     NS_LOG_FUNCTION(this);
     return m_peerAddr;
 }
 
 uint16_t
-Ipv4EndPoint::GetPeerPort()
+Ipv4EndPoint::GetPeerPort() const
 {
     NS_LOG_FUNCTION(this);
     return m_peerPort;
@@ -101,7 +101,7 @@
 }
 
 Ptr<NetDevice>
-Ipv4EndPoint::GetBoundNetDevice()
+Ipv4EndPoint::GetBoundNetDevice() const
 {
     NS_LOG_FUNCTION(this);
     return m_boundnetdevice;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-end-point.h ns-3.39/src/internet/model/ipv4-end-point.h
--- ns-3.38/src/internet/model/ipv4-end-point.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-end-point.h	2023-07-05 14:23:47.845427500 -0700
@@ -62,7 +62,7 @@
      * \brief Get the local address.
      * \return the local address
      */
-    Ipv4Address GetLocalAddress();
+    Ipv4Address GetLocalAddress() const;
 
     /**
      * \brief Set the local address.
@@ -74,19 +74,19 @@
      * \brief Get the local port.
      * \return the local port
      */
-    uint16_t GetLocalPort();
+    uint16_t GetLocalPort() const;
 
     /**
      * \brief Get the peer address.
      * \return the peer address
      */
-    Ipv4Address GetPeerAddress();
+    Ipv4Address GetPeerAddress() const;
 
     /**
      * \brief Get the peer port.
      * \return the peer port
      */
-    uint16_t GetPeerPort();
+    uint16_t GetPeerPort() const;
 
     /**
      * \brief Set the peer information (address and port).
@@ -124,7 +124,7 @@
      *
      * \returns Pointer to interface.
      */
-    Ptr<NetDevice> GetBoundNetDevice();
+    Ptr<NetDevice> GetBoundNetDevice() const;
 
     // Called from socket implementations to get notified about important events.
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-global-routing.cc ns-3.39/src/internet/model/ipv4-global-routing.cc
--- ns-3.38/src/internet/model/ipv4-global-routing.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-global-routing.cc	2023-07-05 14:23:47.845427500 -0700
@@ -18,10 +18,10 @@
 #include "ipv4-global-routing.h"
 
 #include "global-route-manager.h"
+#include "ipv4-route.h"
+#include "ipv4-routing-table-entry.h"
 
 #include "ns3/boolean.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv4-routing-table-entry.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
 #include "ns3/net-device.h"
@@ -473,10 +473,10 @@
 Ipv4GlobalRouting::RouteInput(Ptr<const Packet> p,
                               const Ipv4Header& header,
                               Ptr<const NetDevice> idev,
-                              UnicastForwardCallback ucb,
-                              MulticastForwardCallback mcb,
-                              LocalDeliverCallback lcb,
-                              ErrorCallback ecb)
+                              const UnicastForwardCallback& ucb,
+                              const MulticastForwardCallback& mcb,
+                              const LocalDeliverCallback& lcb,
+                              const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << header.GetSource() << header.GetDestination() << idev
                          << &lcb << &ecb);
@@ -504,7 +504,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, header, Socket::ERROR_NOROUTETOHOST);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-global-routing.h ns-3.39/src/internet/model/ipv4-global-routing.h
--- ns-3.38/src/internet/model/ipv4-global-routing.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-global-routing.h	2023-07-05 14:23:47.845427500 -0700
@@ -96,10 +96,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv4InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-l3-protocol.cc ns-3.39/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.38/src/internet/model/ipv4-l3-protocol.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-l3-protocol.cc	2023-07-05 14:23:47.849427500 -0700
@@ -22,16 +22,15 @@
 #include "arp-cache.h"
 #include "arp-l3-protocol.h"
 #include "icmpv4-l4-protocol.h"
+#include "ipv4-header.h"
 #include "ipv4-interface.h"
 #include "ipv4-raw-socket-impl.h"
+#include "ipv4-route.h"
 #include "loopback-net-device.h"
 
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv4-routing-table-entry.h"
 #include "ns3/log.h"
 #include "ns3/net-device.h"
 #include "ns3/node.h"
@@ -134,6 +133,10 @@
 Ipv4L3Protocol::Ipv4L3Protocol()
 {
     NS_LOG_FUNCTION(this);
+    m_ucb = MakeCallback(&Ipv4L3Protocol::IpForward, this);
+    m_mcb = MakeCallback(&Ipv4L3Protocol::IpMulticastForward, this);
+    m_lcb = MakeCallback(&Ipv4L3Protocol::LocalDeliver, this);
+    m_ecb = MakeCallback(&Ipv4L3Protocol::RouteInputError, this);
 }
 
 Ipv4L3Protocol::~Ipv4L3Protocol()
@@ -535,11 +538,10 @@
 #ifdef NOTYET
         if (MulticastCheckGroup(iif, address))
 #endif
-            if (true)
-            {
-                NS_LOG_LOGIC("For me (Ipv4Addr multicast address)");
-                return true;
-            }
+        {
+            NS_LOG_LOGIC("For me (Ipv4Addr multicast address)");
+            return true;
+        }
     }
 
     if (address.IsBroadcast())
@@ -674,13 +676,7 @@
     }
 
     NS_ASSERT_MSG(m_routingProtocol, "Need a routing protocol object to process packets");
-    if (!m_routingProtocol->RouteInput(packet,
-                                       ipHeader,
-                                       device,
-                                       MakeCallback(&Ipv4L3Protocol::IpForward, this),
-                                       MakeCallback(&Ipv4L3Protocol::IpMulticastForward, this),
-                                       MakeCallback(&Ipv4L3Protocol::LocalDeliver, this),
-                                       MakeCallback(&Ipv4L3Protocol::RouteInputError, this)))
+    if (!m_routingProtocol->RouteInput(packet, ipHeader, device, m_ucb, m_mcb, m_lcb, m_ecb))
     {
         NS_LOG_WARN("No route found for forwarding packet.  Drop.");
         m_dropTrace(ipHeader, packet, DROP_NO_ROUTE, this, interface);
@@ -963,7 +959,7 @@
     uint64_t srcDst = dst | (src << 32);
     std::pair<uint64_t, uint8_t> key = std::make_pair(srcDst, protocol);
 
-    if (mayFragment == true)
+    if (mayFragment)
     {
         ipHeader.SetMayFragment();
         ipHeader.SetIdentification(m_identification[key]);
@@ -1092,8 +1088,7 @@
     if (ipHeader.GetTtl() == 0)
     {
         // Do not reply to multicast/broadcast IP address
-        if (ipHeader.GetDestination().IsBroadcast() == false &&
-            ipHeader.GetDestination().IsMulticast() == false)
+        if (!ipHeader.GetDestination().IsBroadcast() && !ipHeader.GetDestination().IsMulticast())
         {
             Ptr<Icmpv4L4Protocol> icmp = GetIcmp();
             icmp->SendTimeExceededTtl(ipHeader, packet, false);
@@ -1129,7 +1124,7 @@
         NS_LOG_LOGIC("Received a fragment, processing " << *p);
         bool isPacketComplete;
         isPacketComplete = ProcessFragment(p, ipHeader, iif);
-        if (isPacketComplete == false)
+        if (!isPacketComplete)
         {
             return;
         }
@@ -1146,7 +1141,7 @@
         // we need to make a copy in the unlikely event we hit the
         // RX_ENDPOINT_UNREACH codepath
         Ptr<Packet> copy = p->Copy();
-        enum IpL4Protocol::RxStatus status = protocol->Receive(p, ipHeader, GetInterface(iif));
+        IpL4Protocol::RxStatus status = protocol->Receive(p, ipHeader, GetInterface(iif));
         switch (status)
         {
         case IpL4Protocol::RX_OK:
@@ -1156,8 +1151,7 @@
         case IpL4Protocol::RX_CSUM_FAILED:
             break;
         case IpL4Protocol::RX_ENDPOINT_UNREACH:
-            if (ipHeader.GetDestination().IsBroadcast() == true ||
-                ipHeader.GetDestination().IsMulticast() == true)
+            if (ipHeader.GetDestination().IsBroadcast() || ipHeader.GetDestination().IsMulticast())
             {
                 break; // Do not reply to broadcast or multicast
             }
@@ -1173,7 +1167,7 @@
                     subnetDirected = true;
                 }
             }
-            if (subnetDirected == false)
+            if (!subnetDirected)
             {
                 GetIcmp()->SendDestUnreachPort(ipHeader, copy);
             }
@@ -1268,7 +1262,7 @@
         Ipv4InterfaceAddress test = GetAddress(interfaceIdx, i);
         if (test.GetLocal().CombineMask(test.GetMask()) == dest.CombineMask(test.GetMask()))
         {
-            if (test.IsSecondary() == false)
+            if (!test.IsSecondary())
             {
                 return test.GetLocal();
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-l3-protocol.h ns-3.39/src/internet/model/ipv4-l3-protocol.h
--- ns-3.38/src/internet/model/ipv4-l3-protocol.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-l3-protocol.h	2023-07-05 14:23:47.849427500 -0700
@@ -630,6 +630,11 @@
     Time m_expire;      //!< duplicate entry expiration delay
     Time m_purge;       //!< time between purging expired duplicate entries
     EventId m_cleanDpd; //!< event to cleanup expired duplicate entries
+
+    Ipv4RoutingProtocol::UnicastForwardCallback m_ucb;   ///< Unicast forward callback
+    Ipv4RoutingProtocol::MulticastForwardCallback m_mcb; ///< Multicast forward callback
+    Ipv4RoutingProtocol::LocalDeliverCallback m_lcb;     ///< Local delivery callback
+    Ipv4RoutingProtocol::ErrorCallback m_ecb;            ///< Error callback
 };
 
 } // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-list-routing.cc ns-3.39/src/internet/model/ipv4-list-routing.cc
--- ns-3.38/src/internet/model/ipv4-list-routing.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-list-routing.cc	2023-07-05 14:23:47.849427500 -0700
@@ -18,9 +18,9 @@
 
 #include "ipv4-list-routing.h"
 
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv4-static-routing.h"
-#include "ns3/ipv4.h"
+#include "ipv4-route.h"
+#include "ipv4.h"
+
 #include "ns3/log.h"
 #include "ns3/node.h"
 
@@ -105,7 +105,7 @@
 Ipv4ListRouting::RouteOutput(Ptr<Packet> p,
                              const Ipv4Header& header,
                              Ptr<NetDevice> oif,
-                             enum Socket::SocketErrno& sockerr)
+                             Socket::SocketErrno& sockerr)
 {
     NS_LOG_FUNCTION(this << p << header.GetDestination() << header.GetSource() << oif << sockerr);
     Ptr<Ipv4Route> route;
@@ -136,10 +136,10 @@
 Ipv4ListRouting::RouteInput(Ptr<const Packet> p,
                             const Ipv4Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb)
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << idev << &ucb << &mcb << &lcb << &ecb);
     bool retVal = false;
@@ -151,7 +151,7 @@
     uint32_t iif = m_ipv4->GetInterfaceForDevice(idev);
 
     retVal = m_ipv4->IsDestinationAddress(header.GetDestination(), iif);
-    if (retVal == true)
+    if (retVal)
     {
         NS_LOG_LOGIC("Address " << header.GetDestination() << " is a match for local delivery");
         if (header.GetDestination().IsMulticast())
@@ -168,7 +168,7 @@
         }
     }
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, header, Socket::ERROR_NOROUTETOHOST);
@@ -178,7 +178,7 @@
     // If we have already delivered a packet locally (e.g. multicast)
     // we suppress further downstream local delivery by nulling the callback
     LocalDeliverCallback downstreamLcb = lcb;
-    if (retVal == true)
+    if (retVal)
     {
         downstreamLcb = MakeNullCallback<void, Ptr<const Packet>, const Ipv4Header&, uint32_t>();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-list-routing.h ns-3.39/src/internet/model/ipv4-list-routing.h
--- ns-3.38/src/internet/model/ipv4-list-routing.h	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-list-routing.h	2023-07-05 14:23:47.849427500 -0700
@@ -88,10 +88,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv4InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-packet-filter.cc ns-3.39/src/internet/model/ipv4-packet-filter.cc
--- ns-3.38/src/internet/model/ipv4-packet-filter.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-packet-filter.cc	2023-07-05 14:23:47.849427500 -0700
@@ -26,8 +26,6 @@
 
 #include "ns3/enum.h"
 #include "ns3/log.h"
-#include "ns3/tcp-header.h"
-#include "ns3/udp-header.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-packet-probe.cc ns-3.39/src/internet/model/ipv4-packet-probe.cc
--- ns-3.38/src/internet/model/ipv4-packet-probe.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-packet-probe.cc	2023-07-05 14:23:47.849427500 -0700
@@ -20,7 +20,7 @@
  * Modified by: Mitch Watrous (watrous@u.washington.edu)
  */
 
-#include "ns3/ipv4-packet-probe.h"
+#include "ipv4-packet-probe.h"
 
 #include "ns3/config.h"
 #include "ns3/log.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-queue-disc-item.cc ns-3.39/src/internet/model/ipv4-queue-disc-item.cc
--- ns-3.38/src/internet/model/ipv4-queue-disc-item.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/ipv4-queue-disc-item.cc	2023-07-05 14:23:47.849427500 -0700
@@ -17,9 +17,10 @@
 
 #include "ipv4-queue-disc-item.h"
 
+#include "tcp-header.h"
+#include "udp-header.h"
+
 #include "ns3/log.h"
-#include "ns3/tcp-header.h"
-#include "ns3/udp-header.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-raw-socket-impl.cc ns-3.39/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.38/src/internet/model/ipv4-raw-socket-impl.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-raw-socket-impl.cc	2023-07-05 14:23:47.849427500 -0700
@@ -1,18 +1,18 @@
 #include "ipv4-raw-socket-impl.h"
 
 #include "icmpv4.h"
-#include "ipv4-l3-protocol.h"
+#include "ipv4-packet-info-tag.h"
+#include "ipv4-routing-protocol.h"
 
 #include "ns3/boolean.h"
 #include "ns3/inet-socket-address.h"
-#include "ns3/ipv4-packet-info-tag.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
 #include "ns3/uinteger.h"
 
 #ifdef __WIN32__
-#include "ns3/win32-internet.h"
+#include "win32-internet.h"
 #else
 #include <netinet/in.h>
 #include <sys/socket.h>
@@ -88,14 +88,14 @@
     Socket::DoDispose();
 }
 
-enum Socket::SocketErrno
+Socket::SocketErrno
 Ipv4RawSocketImpl::GetErrno() const
 {
     NS_LOG_FUNCTION(this);
     return m_err;
 }
 
-enum Socket::SocketType
+Socket::SocketType
 Ipv4RawSocketImpl::GetSocketType() const
 {
     NS_LOG_FUNCTION(this);
@@ -526,11 +526,7 @@
 Ipv4RawSocketImpl::SetAllowBroadcast(bool allowBroadcast)
 {
     NS_LOG_FUNCTION(this << allowBroadcast);
-    if (!allowBroadcast)
-    {
-        return false;
-    }
-    return true;
+    return allowBroadcast;
 }
 
 bool
